<?php

/**
 * Plugin Name: Tavalode Custom Payment Method
 * Plugin URI:  https://mahdimohebi.ir/my-plugins/
 * Description: tavalode custom payment method
 * Version:     1.0.2
 * Author:      Mahdi Mohebi
 * Author URI:  https://mahdimohebi.ir/
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Text Domain: mmtcpm  
 * Domain Path: /languages
 * 
 */


add_filter( 'woocommerce_available_payment_gateways', 'bbloomer_payment_gateway_disable_country' );
 
function bbloomer_payment_gateway_disable_country( $available_gateways ) {
    //if ( is_admin() ) return $available_gateways;
    //if ( isset( $available_gateways['authorize'] ) && WC()->customer->get_billing_country() <> 'US' ) {
    //    unset( $available_gateways['authorize'] );
   // } else {
   // }//method_exists($this->controller, $this->view)
   if(isset(WC()->customer)){
	if ( isset( $available_gateways['deliver_gateway'] ) && WC()->customer->get_billing_state() != 'THR' ) {
            unset( $available_gateways['deliver_gateway'] );
    }
   }
    return $available_gateways;
}




// Make sure WooCommerce is active
if ( ! in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
	return;
}


/**
 * Add the gateway to WC Available Gateways
 * 
 * @since 1.0.0
 * @param array $gateways all available WC gateways
 * @return array $gateways all WC gateways + deliver gateway
 */
function wc_deliver_add_to_gateways( $gateways ) {
	$gateways[] = 'WC_Gateway_deliver';
	return $gateways;
}
add_filter( 'woocommerce_payment_gateways', 'wc_deliver_add_to_gateways' );


/**
 * Adds plugin page links
 * 
 * @since 1.0.0
 * @param array $links all plugin links
 * @return array $links all plugin links + our custom links (i.e., "Settings")
 */
function wc_deliver_gateway_plugin_links( $links ) {

	$plugin_links = array(
		'<a href="' . admin_url( 'admin.php?page=wc-settings&tab=checkout&section=deliver_gateway' ) . '">' . __( 'Configure', 'mmtcpm' ) . '</a>'
	);

	return array_merge( $plugin_links, $links );
}
add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'wc_deliver_gateway_plugin_links' );


/**
 * پرداخت هنگام تحویل Gateway
 *
 * Provides an پرداخت هنگام تحویل Gateway; mainly for testing purposes.
 * We load it later to ensure WC is loaded first since we're extending it.
 *
 * @class 		WC_Gateway_deliver
 * @extends		WC_Payment_Gateway
 * @version		1.0.0
 * @package		WooCommerce/Classes/Payment
 * @author 		SkyVerge
 */
add_action( 'plugins_loaded', 'wc_deliver_gateway_init', 11 );

function wc_deliver_gateway_init() {

	class WC_Gateway_deliver extends WC_Payment_Gateway {

		/**
		 * Constructor for the gateway.
		 */
		public function __construct() {
	  
			$this->id                 = 'deliver_gateway';
			$this->icon               = apply_filters('woocommerce_deliver_icon', '');
			$this->has_fields         = false;
			$this->method_title       = __( 'deliver', 'mmtcpm' );
			$this->method_description = __( 'پرداخت هنگام تحویل فقط برای تهران', 'mmtcpm' );
		  
			// Load the settings.
			$this->init_form_fields();
			$this->init_settings();
		  
			// Define user set variables
			$this->title        = $this->get_option( 'title' );
			$this->description  = $this->get_option( 'description' );
			$this->instructions = $this->get_option( 'instructions', $this->description );
		  
			// Actions
			add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
			add_action( 'woocommerce_thankyou_' . $this->id, array( $this, 'thankyou_page' ) );
		  
			// Customer Emails
			add_action( 'woocommerce_email_before_order_table', array( $this, 'email_instructions' ), 10, 3 );
		}
	
	
		/**
		 * Initialize Gateway Settings Form Fields
		 */
		public function init_form_fields() {
	  
			$this->form_fields = apply_filters( 'wc_deliver_form_fields', array(
		  
				'enabled' => array(
					'title'   => __( 'Enable/Disable', 'mmtcpm' ),
					'type'    => 'checkbox',
					'label'   => __( 'فعال سازی پرداخت هنگام تحویل', 'mmtcpm' ),
					'default' => 'yes'
				),
				
				'title' => array(
					'title'       => __( 'Title', 'mmtcpm' ),
					'type'        => 'text',
					'description' => __( 'This controls the title for the payment method the customer sees during checkout.', 'mmtcpm' ),
					'default'     => __( 'پرداخت هنگام تحویل', 'mmtcpm' ),
					'desc_tip'    => true,
				),
				
				'description' => array(
					'title'       => __( 'Description', 'mmtcpm' ),
					'type'        => 'textarea',
					'description' => __( 'Payment method description that the customer will see on your checkout.', 'mmtcpm' ),
					'default'     => __( 'پرداخت هنگام تحویل - فقط برای تهران', 'mmtcpm' ),
					'desc_tip'    => true,
				),
				
				'instructions' => array(
					'title'       => __( 'Instructions', 'mmtcpm' ),
					'type'        => 'textarea',
					'description' => __( 'دستورالعمل برای صفحه تشکر از پرداخت و ایمیل', 'mmtcpm' ),
					'default'     => '',
					'desc_tip'    => true,
				),
			) );
		}
	
	
		/**
		 * Output for the order received page.
		 */
		public function thankyou_page() {
			if ( $this->instructions ) {
				echo wpautop( wptexturize( $this->instructions ) );
			}
		}
	
	
		/**
		 * Add content to the WC emails.
		 *
		 * @access public
		 * @param WC_Order $order
		 * @param bool $sent_to_admin
		 * @param bool $plain_text
		 */
		public function email_instructions( $order, $sent_to_admin, $plain_text = false ) {
		
			if ( $this->instructions && ! $sent_to_admin && $this->id === $order->payment_method && $order->has_status( 'on-hold' ) ) {
				echo wpautop( wptexturize( $this->instructions ) ) . PHP_EOL;
			}
		}
	
	
		/**
		 * Process the payment and return the result
		 *
		 * @param int $order_id
		 * @return array
		 */
		public function process_payment( $order_id ) {
	
			$order = wc_get_order( $order_id );
			
			// Mark as on-hold (we're awaiting the payment)
			$order->update_status( 'processing', __( 'در حال انجام', 'mmtcpm' ) );
			
			// Reduce stock levels
			$order->reduce_order_stock();
			
			// Remove cart
			WC()->cart->empty_cart();
			
			// Return thankyou redirect
			return array(
				'result' 	=> 'success',
				'redirect'	=> $this->get_return_url( $order )
			);
		}
	
  } // end \WC_Gateway_deliver class
}